=== tools/CMakeLists.txt ===
add_subdirectory(dscat)
add_subdirectory(lsvast)
