=== pyvast/example/requirements.txt ===
pandas>=1
pyarrow>=0.16
