=== vast/integration/requirements.txt ===
coloredlogs==10.0
jsondiff>=1.2.0
pyyaml>=4.2b1
schema==0.6.8
