=== examples/plugins/analyzer/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15...3.20 FATAL_ERROR)

project(example-analyzer
  DESCRIPTION "Example analyzer plugin for VAST"
  LANGUAGES CXX)

# Enable unit testing. Note that it is necessary to include CTest in the
# top-level CMakeLists.txt file for it to create a test target, so while
# optional for plugins built alongside VAST, it is necessary to specify this
# line manually so plugins can be linked against an installed VAST.
include(CTest)

find_package(VAST REQUIRED)
VASTRegisterPlugin(
  TARGET example-analyzer
  ENTRYPOINT
    example_analyzer.cpp
  # SOURCES
  #   list additional source files here
  TEST_SOURCES
    tests/example_analyzer.cpp)
