=== debian/changelog ===
vast (2021.05.27-8) unstable; urgency=medium

  * Add missing include in header file.
    Closes: 997276

 -- Sascha Steinbiss <satta@debian.org>  Sun, 31 Oct 2021 10:54:40 +0100

vast (2021.05.27-7) unstable; urgency=medium

  * Place vast-dev into libdevel section. Thanks to Jonas Smedegaard for the
    hint.
    Closes: #993924
  * Bump Standards-Version.
  * Reword short description for vast-dev to be shorter.
  * Enable all hardening flags.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 08 Sep 2021 21:33:10 +0200

vast (2021.05.27-6) unstable; urgency=medium

  * Fix autopkgtest by updating query language syntax in test case.

 -- Sascha Steinbiss <satta@debian.org>  Sun, 29 Aug 2021 22:14:41 +0200

vast (2021.05.27-5) unstable; urgency=medium

  * Upload to unstable post-release.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 18 Aug 2021 09:07:15 +0200

vast (2021.05.27-4) experimental; urgency=medium

  * Introduce conditional installation of test related files
    by architecture.

 -- Sascha Steinbiss <satta@debian.org>  Fri, 11 Jun 2021 16:43:26 +0200

vast (2021.05.27-3) experimental; urgency=medium

  * Introduce vast-dev.
  * Build tests only on selected archs.

 -- Sascha Steinbiss <satta@debian.org>  Fri, 28 May 2021 09:01:51 +0200

vast (2021.05.27-2) experimental; urgency=medium

  * Run tests only on selected archs.

 -- Sascha Steinbiss <satta@debian.org>  Thu, 27 May 2021 12:10:22 +0200

vast (2021.05.27-1) experimental; urgency=medium

  * New upstream release.
  * Re-enable tests.

 -- Sascha Steinbiss <satta@debian.org>  Thu, 27 May 2021 10:21:05 +0200

vast (2021.04.29-1) experimental; urgency=medium

  * New upstream release.
  * Remove patches applied upstream.
  * Update bundled default config file.
  * Adjust d/copyright paths.

 -- Sascha Steinbiss <satta@debian.org>  Mon, 03 May 2021 20:48:10 +0200

vast (2021.03.25-1) experimental; urgency=medium

  * New upstream release.
  * Update d/vast.yaml to match new example format.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 31 Mar 2021 12:58:30 +0200
