=== debian/control ===
Source: vast
Section: database
Priority: optional
Maintainer: Sascha Steinbiss <satta@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               cmake,
               flatbuffers-compiler,
               libflatbuffers-dev,
               libfmt-dev,
               libspdlog-dev (>= 1:1.5),
               libjemalloc-dev,
               libpcap-dev,
               libssl-dev,
               libyaml-cpp-dev,
               libcaf-dev (>= 0.17.6),
               robin-map-dev,
               libsimdjson-dev,
               pandoc,
               asciidoctor,
               doxygen
Standards-Version: 4.6.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/vast
Vcs-Git: https://salsa.debian.org/debian/vast.git
Homepage: https://github.com/tenzir/vast

Package: vast
Architecture: amd64 arm64 ppc64el s390x
Depends: ${shlibs:Depends},
         ${misc:Depends},
         adduser
Description: network telemetry engine for data-driven security investigations
 VAST is a distributed platform for high-performance network forensics and
 incident response that provides both continuous ingestion of voluminous event
 streams and interactive query performance.
 VAST leverages a native implementation of the actor model to scale both
 intra-machine across available CPU cores, and inter-machine over a cluster of
 commodity systems.
 .
 This package contains the VAST main executables.

Package: vast-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el s390x
Depends: ${misc:Depends},
         vast (= ${binary:Version}),
         robin-map-dev (>= 0.6),
         libcaf-dev (>= 0.17.6),
         libflatbuffers-dev,
         libfmt-dev,
         libspdlog-dev (>= 1:1.5),
         libjemalloc-dev,
         libpcap-dev,
         libssl-dev,
         libyaml-cpp-dev
Description: header files for VAST plugin development
 VAST is a distributed platform for high-performance network forensics and
 incident response that provides both continuous ingestion of voluminous event
 streams and interactive query performance.
 VAST leverages a native implementation of the actor model to scale both
 intra-machine across available CPU cores, and inter-machine over a cluster of
 commodity systems.
 .
 This package contains development resources for building VAST plugins.
